/**
DISPATCH VIEW CONTROLLER - REFACTORING BY MAREK KOSAR
START 6/3/2016
*/

public with sharing class FM_DispatchViewNewController{

    public static final String CLASS_NAME = 'FM_DispatchViewNewController';

    // list of wrapper for the truck trips
    private List<TruckTripWrapper> truckListWrapperList {get; set;}
    private Map<Id, TruckTripWrapper> truckTripWrapperMap {get; set;}

    // set of selected truck trips
    private Set<Id> truckTripSelectedSet;

    //Filters & Sorting
    public FilterWrapper currentPageFilter {get; set;}
    public SortingWrapper sortOptions {get; set;}

    public String applyItem {get; set;}

    public List<SelectOption> picklistToDisplay {get; set;}
    public String valueSelected {get; set;}
    public String massUpdateCancelReason {get; set;}
    public String massUpdateCancelComments {get; set;}

    //cancel popup
    public Boolean          showCancelPopup     {get;set;}
    public FM_Truck_Trip__c truckTripCancel     {get;set;}
    public String           truckTripOldStatus  {get;set;}
    public Boolean          isCancelError       {get;set;}
    public String           cancelError         {get;set;}

    public static String TRUCKTRIP_STATUS_CANCELLED {
        get {
            return FM_Utilities.TRUCKTRIP_STATUS_CANCELLED;
        }
        set;
    }

    public static String TRUCKTRIP_STATUS_REDISPATCH{
        get {
            return FM_Utilities.TRUCKTRIP_STATUS_REDISPATCH;
        }
        set;
    }

    public static String TRUCKTRIP_STATUS_EXPORTED {
        get {
            return FM_Utilities.TRUCKTRIP_STATUS_EXPORTED;
        }
        set;
    }

    public static String TRUCKTRIP_STATUS_GIVENBACK {
        get {
            return FM_Utilities.TRUCKTRIP_STATUS_GIVENBACK;
        }
        set;
    }

    public static final Integer locationLimit = 1000;

    public Boolean searchOccurred{
        get{
            if (searchOccurred == null){

                searchOccurred = false;
            }
            return searchOccurred;
        }
        private set;
    }

    public Boolean selectAllCheckbox {get; set;}

    // a dynamic SOQL string
    private String truckTripSOQLString;

    // a single instance of Truck List, so that the date filter can be rendered as a date field, not a text field.
    public Boolean runSheetDateTodayInd {get; private set;}
    public Boolean runSheetDateOldButBeforeDeadlineInd {get; private set;}

    private Boolean bSaveAllowed; // * ADDED BY GM 2015-08-10 * BOOLEAN THAT DETERMINES IF SAVING IS ALLOWED -> NEEDS TO START FALSE FOR URL PARAMETER SEARCHING TO WORK

    // map of facility summaries
    public Map<String, FM_FacilitySummary.FacilityDataWrapper> facilityCapacitySummaryMap {get; set;}

    //Flag to reload records
    private Boolean reloadRecords = true;

    public FM_DispatchViewNewController()
    {
        this.bSaveAllowed = false;
        this.init();
        this.initCancelPopup();
        this.LoadUrlParameters();
        this.BuildTruckTripSOQLQuery();
        this.bSaveAllowed = true;
    }

    public void init() {
        this.truckListWrapperList = new List<TruckTripWrapper>();
        this.truckTripSelectedSet = new Set<Id>();
        this.truckTripWrapperMap = new Map<Id, TruckTripWrapper>();
        this.runSheetDateTodayInd = false;
        this.runSheetDateOldButBeforeDeadlineInd = false;
        this.currentPageFilter = new FilterWrapper();
        this.sortOptions = new SortingWrapper();
    }

    private void initCancelPopup() {
        this.showCancelPopup = false;
        this.truckTripCancel = null;
        this.isCancelError = false;
        this.truckTripOldStatus = '';
        this.cancelError = '';
    }

    public void BuildTruckTripSOQLQuery() {
        truckTripSetController = null;
        System.debug('searchOccurred: ' + searchOccurred);
        if(searchOccurred || String.isEmpty(truckTripSOQLString)) {
            truckTripSOQLString = FM_Utilities.QUERY_DISPATCH_TRUCK_TRIPS +
                currentPageFilter.getFilterString() + sortOptions.getSortString();
            System.debug(' truckTripSOQLString: ' + truckTripSOQLString);
            searchOccurred = false;
        }
        if(!String.isBlank(String.valueOf(currentPageFilter.runSheetDate))) {
            runSheetDateTodayInd = (currentPageFilter.runSheetDate == System.today());
            runSheetDateOldButBeforeDeadlineInd = FM_Utilities.canEditTruckList(currentPageFilter.runSheetDate);
        }
    }

    // used to run the SOQL and used for next and previous navigation
    public ApexPages.StandardSetController truckTripSetController
    {
        get
        {
            if (truckTripSetController == null)
            {
                truckTripSetController = new ApexPages.StandardSetController(Database.getQueryLocator(truckTripSOQLString));
                truckTripSetController.setPageSize(50);
            }
            return truckTripSetController;
        }
        set;
    }

    // display the result of the SOQL
    public List<TruckTripWrapper> getCurrentTruckTripList()
    {
        if(reloadRecords) {
            List<FM_Truck_Trip__c> records = (list<FM_Truck_Trip__c>) truckTripSetController.getRecords();
            truckListWrapperList = new List<TruckTripWrapper>();

            //Get Facility Summary Data
            this.facilityCapacitySummaryMap = FM_Utilities.GetFacilityCapacitySummaryMap(getNewTruckTrips(records));

            for (FM_Truck_Trip__c tt : records)
            {
                TruckTripWrapper oldTruckTripWrapper = truckTripWrapperMap.get(tt.Id);
                TruckTripWrapper newTruckTripWrapper = new TruckTripWrapper(tt, false, this.facilityCapacitySummaryMap);

                //Save state variables
                if(oldTruckTripWrapper != null) {
                    //newTruckTripWrapper.destinationConfirmationPopupState = (oldTruckTripWrapper != null) ? oldTruckTripWrapper.destinationConfirmationPopupState : new PopupState();

                    //Checkbox
                    newTruckTripWrapper.aCheckBox = oldTruckTripWrapper.aCheckBox;

                    //Copy Input Fields
                    if(newTruckTripWrapper.aTruckTrip.Truck_Trip_Status__c == 'Carryover' || newTruckTripWrapper.aTruckTrip.Truck_Trip_Status__c == 'Cancelled') {
                        if(oldTruckTripWrapper.aTruckTrip.Truck_Trip_Status__c == 'Booked' || oldTruckTripWrapper.aTruckTrip.Truck_Trip_Status__c == 'New') {
                             newTruckTripWrapper.aFacilityPicklistValue = null;
                        }
                    }
                    else {

                        //newTruckTripWrapper.aFacilityPicklistValue = oldTruckTripWrapper.aFacilityPicklistValue;
                    }

                }

                truckListWrapperList.add(newTruckTripWrapper);
                truckTripWrapperMap.put(tt.Id, newTruckTripWrapper);
            }
        }
        return truckListWrapperList;
    }

    public PageReference ToggleAllTruckTripCheckboxes()
    {
        // have to be at least today or yesterday (but within grace period) for the toggle button to be enabled.
        // If not, then no checkbox will be change-able, don't need to toggle and don't need to update the selected set.
        // ttWrapper.aCheckBox = selectAllCheckbox
        if (runSheetDateTodayInd || runSheetDateOldButBeforeDeadlineInd || getIsExportedTruckTrips())
        {
            for (TruckTripWrapper ttWrapper : truckListWrapperList)
            {
                
                if (runSheetDateTodayInd || (runSheetDateOldButBeforeDeadlineInd && ttWrapper.aTruckTrip.Shift__c == 'Day') 
                    || ttWrapper.aTruckTrip.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_EXPORTED)
                {
                    if (ttWrapper.aTruckTrip.Truck_Trip_Status__c != TRUCKTRIP_STATUS_CANCELLED) {
                        ttWrapper.aCheckBox = selectAllCheckbox;
                    }
                }
                System.debug('TT: ' + ttWrapper.aTruckTrip.Name + selectAllCheckbox + '->' + ttWrapper.aCheckBox + ' | ' + 'RsTodayInd:' + runSheetDateTodayInd + ' | BeforeDeadInd:' + runSheetDateOldButBeforeDeadlineInd + ' | Shift:' + ttWrapper.aTruckTrip.Shift__c + ' |Status:' + ttWrapper.aTruckTrip.Truck_Trip_Status__c);
            }
            //return UpdateTruckTripSelectedSet();
        }
        return null;
    }

    public PageReference clearAllTruckTripCheckboxes() {
        selectAllCheckbox = false;
        for(TruckTripWrapper ttWrapper : truckListWrapperList) {
            ttWrapper.aCheckBox = false;
        }
        return null;
    }

    public PageReference clearAllSelectCheckbox() {
        Boolean unchecked = ApexPages.currentPage().getParameters().get('checkboxValue') == 'false';
        if(unchecked) selectAllCheckbox = false;
        return null;
    }

    public PageReference clearMassUpdateSelections() {
        applyItem = null;
        valueSelected = null;
        return null;
    }

    public void handleCancelReasonChange() {
        if (String.isNotBlank(massUpdateCancelReason)
            && massUpdateCancelReason != 'Other')
            massUpdateCancelComments = '';
    }

    // despite the name, this method only creates the query string.  The VF's reRender will cause the query to be executed.
    public PageReference SearchTruckTrips()
    {
        // SAVING IS ALLOWED?
        if(bSaveAllowed == true)
        {
            //SaveTruckTrips(true);
        }

        //clear all checkboxes
        clearAllTruckTripCheckboxes();

        // clear truck trip wrapper to optimize page view state
        truckTripWrapperMap.clear();

        // clear mass update selections
        clearMassUpdateSelections();

        if(currentPageFilter.runSheetDate == null || currentPageFilter.searchRoutes == null || currentPageFilter.searchRoutes.isEmpty()) {
            ApexPages.addMessage(new ApexPages.message(ApexPages.severity.FATAL, 'Please provide a Run Sheet Date AND at least one Route for your Search Criteria.'));
        }
        else {
            searchOccurred = true;
            currentPageFilter.sour = null;
            currentPageFilter.unit = '';
            BuildTruckTripSOQLQuery();
        }

        return null;
    }


    public PageReference AddLoadRequestsRedirect() {
        PageReference pageRef = Page.FM_AddLoadRequest;
        pageRef.setRedirect(true);
        return pageRef;
    }

    /**
    Cancel popup logic
    */
    public PageReference openCancelPopup() {
        String truckTripId = ApexPages.currentPage().getParameters().get('truckTripId');
        if (String.isNotBlank(truckTripId)) {
            truckTripOldStatus = ApexPages.currentPage().getParameters().get('oldTruckTripStatus');
            truckTripCancel = truckTripWrapperMap.get(truckTripId).aTruckTrip;
            if (truckTripCancel.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_CANCELLED)
                showCancelPopup = true;
            else initCancelPopup();
        }
        return null;
    }

    public void closeCancelPopup() {
        truckTripCancel.Truck_Trip_Status__c = truckTripOldStatus;
        truckTripCancel.Load_Request_Cancel_Reason__c = '';
        initCancelPopup();
    }

    public void confirmCancelPopup() {
        if (truckTripCancel.Load_Request_Cancel_Reason__c.equals('Other')
            && String.isBlank(truckTripCancel.Load_Request_Cancel_Comments__c)) {
            isCancelError = true;
            cancelError = 'Cancel Comments cannot be blank when Cancel Reason is "Other"';
        } else initCancelPopup();
    }

    public void handleCancelPopupReasonChange() {
        if (String.isNotBlank(truckTripCancel.Load_Request_Cancel_Reason__c)
            && truckTripCancel.Load_Request_Cancel_Reason__c != 'Other')
            truckTripCancel.Load_Request_Cancel_Comments__c = '';
    }

    /**
    SORTING LOGIC
    */

    // if the sort field has not changed, then the sort direction is toggled.
    // if the sort field has changed (user clicks another column header), reset the sort direction to ascending
    public void SortToggle()
    {
        //SaveTruckTrips(false);
        sortOptions.sortDirection = (sortOptions.sortDirection.equals('asc NULLS LAST') ? 'desc NULLS LAST' : 'asc NULLS LAST');
        // if the sort column has changed, then change it back to asc
        if (sortOptions.lastSortField != sortOptions.sortField)
        {
            sortOptions.sortDirection = 'asc NULLS LAST';
            sortOptions.lastSortField = sortOptions.sortField;
        }
        // build the query
        searchOccurred = true;
        BuildTruckTripSOQLQuery();
    }

    /**
    public properties to hold picklist information, used in VF page
    */

    public List<SelectOption> carrierUnitSelectOptionsWithEmptyCarriers {
        get {
            if (carrierUnitSelectOptionsWithEmptyCarriers == null) {
                carrierUnitSelectOptionsWithEmptyCarriers = new List<SelectOption>();
                for (Carrier__c c : FM_Utilities.carrierMap.values()) {
                    Boolean disabled = c.Carrier_Name_For_Fluid__c.contains('Husky');
                    carrierUnitSelectOptionsWithEmptyCarriers.add(new SelectOption(c.Id, c.Carrier_Name_For_Fluid__c, disabled));
                }
                carrierUnitSelectOptionsWithEmptyCarriers.addAll(carrierUnitSelectOptions);
            }
            return carrierUnitSelectOptionsWithEmptyCarriers;
        }
        private set;
    }

    public List<SelectOption> carrierUnitSelectOptions {
        get {
            if (carrierUnitSelectOptions == null) {
                carrierUnitSelectOptions = new List<SelectOption>();
                for (Carrier_Unit__c cu : [SELECT Id, Name, Carrier__c, Carrier__r.Carrier_Name_For_Fluid__c, Enabled__c,
                                                  Carrier__r.Enabled__c
                                            FROM Carrier_Unit__c
                                            WHERE Carrier__r.Carrier_Name_For_Fluid__c LIKE 'Husky%' 
                                                AND Enabled__c = true 
                                                AND Carrier__r.Enabled__c = true 
                                            ORDER BY Carrier__r.Carrier_Name_For_Fluid__c ASC, Name ASC]) {
                    String carrierName = (!cu.Carrier__r.Enabled__c) ? cu.Carrier__r.Carrier_Name_For_Fluid__c + ' (Disabled)' : cu.Carrier__r.Carrier_Name_For_Fluid__c;
                    String unitName = (!cu.Enabled__c) ? cu.Name + ' (Disabled)' : cu.Name;
                    carrierUnitSelectOptions.add(new SelectOption(cu.Carrier__c + '-' + cu.Id, 
                                                                //carrierName + ' - ' + 
                                                                unitName, 
                                                                (!cu.Enabled__c || !cu.Carrier__r.Enabled__c) ? true : false));
                }
            }
            return carrierUnitSelectOptions;
        }
        private set;
    }

    // used to populate the route dropdown for search filter.
    public List<SelectOption> routeSelectOptionList
    {
        get
        {
            if (routeSelectOptionList == null)
            {
                routeSelectOptionList = new List<SelectOption>();

                for (Route__c route : [SELECT Id, Name FROM Route__c WHERE Fluid_Management__c = true ORDER BY Name])
                {
                    routeSelectOptionList.add(new SelectOption(route.Name, route.Name));
                }
            }
            return routeSelectOptionList;

        }
        private set;
    }

    public List<SelectOption> productSelectOptionList
    {
        get
        {
            if (productSelectOptionList == null)
            {
                productSelectOptionList = FM_Utilities.GenerateSelectOptions(FM_Truck_Trip__c.Product__c.getDescribe());
            }
            return productSelectOptionList;
        }
        private set;
    }

    public List<SelectOption> axleSelectOptionList
    {
        get
        {
            if(axleSelectOptionList == null)

            {
                Map<String, String> mapUnitConfigs = FM_Utilities.UnitConfigurationMaps();
                axleSelectOptionList = new List<SelectOption>();

                for(String sOneValue : mapUnitConfigs.keySet())
                {
                    axleSelectOptionList.add(new SelectOption(mapUnitConfigs.get(sOneValue), sOneValue));
                }

            }
            return axleSelectOptionList;
        }
        private set;


    }

    // used to populate the facility dropdown
    public List<SelectOption> facilitySelectOptionList {
        get
        {

            if (facilitySelectOptionList == null)
            {
                facilitySelectOptionList = FM_Utilities.facilityPickList;
            }
            return facilitySelectOptionList;

        }
        private set;
    }

    public List<SelectOption> shiftSelectOptionForFilter {
        get {
            if (shiftSelectOptionForFilter == null) {
                shiftSelectOptionForFilter = new List<SelectOption>();
                for(SelectOption option : shiftSelectOptionList) {
                    SelectOption newOption = new SelectOption(option.getValue(), option.getLabel(), false);
                    shiftSelectOptionForFilter.add(newOption);
                }
            }
            return shiftSelectOptionForFilter;
        }
        private set;
    }

    public List<SelectOption> shiftSelectOptionList {
        get
        {
            if (shiftSelectOptionList == null)
            {
                shiftSelectOptionList = FM_Utilities.GenerateShiftSelectOptions();
            }
            return shiftSelectOptionList;
        }
        private set;
    }

    public List<SelectOption> statusSelectOptionListForMassUpdate()
    {
        List<SelectOption> options = new List<SelectOption>();
        Schema.DescribeFieldResult statusFieldResult = FM_Truck_Trip__c.Truck_Trip_Status__c.getDescribe();
        for (Schema.PicklistEntry statusPicklistEntry : statusFieldResult.getPicklistValues())

        {
            //exclude some statuses
            if (statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_NEW &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_BOOKED &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_REDISPATCH &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_EXPORTED &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_COMPLETED &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKLIST_STATUS_GIVENBACK &&
                statusPicklistEntry.getLabel() != FM_TruckTrip_Utilities.STATUS_UNCANCELLED &&
                statusPicklistEntry.getLabel() != FM_Utilities.TRUCKLIST_STATUS_ADDON) {
                options.add(new SelectOption(statusPicklistEntry.getLabel(), statusPicklistEntry.getLabel()));
            }

        }
        return options;

    }

    public List<SelectOption> statusSelectOptionListForSearch
    {
        get{


            if (statusSelectOptionListForSearch == null)
            {
                statusSelectOptionListForSearch = new List<SelectOption>();
                Schema.DescribeFieldResult statusFieldResult = FM_Truck_Trip__c.Truck_Trip_Status__c.getDescribe();
                for (Schema.PicklistEntry statusPicklistEntry : statusFieldResult.getPicklistValues())
                {
                    // exclude Dispatched status from the picklist - Dispatched is a system status - governed by the parent truck list
                    if (statusPicklistEntry.getLabel() != FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED &&
                        statusPicklistEntry.getLabel() != FM_Utilities.TRUCKLIST_STATUS_GIVENBACK) {
                        statusSelectOptionListForSearch.add(new SelectOption(statusPicklistEntry.getLabel(), statusPicklistEntry.getLabel()));
                    }
                }
            }
            return statusSelectOptionListForSearch;
        }
        private set;
    }

    public List<SelectOption> statusSelectOptionListForEntry
    {
        get{


            if (statusSelectOptionListForEntry == null)
            {
                statusSelectOptionListForEntry = FM_Utilities.GetTruckTripStatusPicklistForEntry();
            }
            return statusSelectOptionListForEntry;
        }
        private set;
    }

    /**
    SAVE BUTTON - run the Save method on the set controller
    */
    public PageReference SaveTruckTrips(Boolean clearCheckBoxes)
    {
        //clear all checkboxes
        if(clearCheckBoxes) clearAllTruckTripCheckboxes();

        return SaveTruckTrips();
    }

    public PageReference SaveTruckTrips() {
        reloadRecords = true;
        Integer currentPage = truckTripSetController.getPageNumber();

        try {
            if(truckTripSetController.Save() == null) {
                reloadRecords = false;
                if (!ApexPages.hasMessages()) {
                    ApexPages.addMessage(new ApexPages.message(ApexPages.severity.FATAL, 'Truck Trip save failed. Try to re-search to see if changes were saved.'));
                    System.debug('SAVE TRUCKTRIPS: FAILURE!');
                    //we can run BuildTruckTripSOQLQuery(); or we can put it in finally block and remove these return null; inside try and catch.
                } else {
                    ApexPages.getMessages().get(0).getSummary().contains('Cancel Comments cannot be blank');
                    reloadRecords = true;
                    BuildTruckTripSOQLQuery();
                    truckTripSetController.setPageNumber(currentPage);
                }
                return null;
            }
        } catch (Exception e) {
            reloadRecords = false;
            ApexPages.addMessage(new ApexPages.message(ApexPages.severity.FATAL, 'Truck Trip save failed.\nERROR: ' + e));
            System.debug('SAVE TRUCKTRIPS: FAILURE! Msg: ' + e);
            return null;
        }

        //Initialize Facility Summary Lists
        FM_Utilities.truckTripsBookedOrDispatched = null;
        FM_Utilities.facilityCapacitySummaryList = null;

        // Need to call BuildTruckTripSOQLQuery otherwise the sorting may not be honoured.
        // That is true if you are editing fields that are the sorting column.
        BuildTruckTripSOQLQuery();
        truckTripSetController.setPageNumber(currentPage);


        return null;
    }

    /**
    MASS UPDATE FUNCITIONALITY
    */

    public PageReference UpdateDependentFilter()
    {
        // Need to reset the valueSelected otherwise when you change the mass update item to something else,

        // there will still be some value selected that are remembered.
        valueSelected = '';

        picklistToDisplay = new List<SelectOption>();

        if (applyItem == 'facility')
        {
            picklistToDisplay = facilitySelectOptionList;
        }
        else if (applyItem == 'unit')
        {   
            picklistToDisplay = carrierUnitSelectOptionsWithEmptyCarriers;
        }
        else if (applyItem == 'shift')
        {
            picklistToDisplay = shiftSelectOptionList;
        }
        else if (applyItem == 'status')
        {
            picklistToDisplay = statusSelectOptionListForMassUpdate();
        }
        return null;
    }


    //Mass update - APPLY BUTTON - ACTION
    public PageReference MassUpdateData()
    {
        
        if (applyItem != '' || valueSelected != '')
        {
            List<FM_Truck_Trip__c> truckTripList = new List<FM_Truck_Trip__c>();

            for (TruckTripWrapper ttWrapper : truckListWrapperList)
            {
                if (ttWrapper.aCheckBox)
                {
                    if (applyItem == 'facility')
                    {
                        
                        if (valueSelected == '' || valueSelected == null)
                        {

                            ttWrapper.aTruckTrip.Location_Lookup__c = null;
                            ttWrapper.aTruckTrip.Facility_Lookup__c = null;
                            ttWrapper.aTruckTrip.Facility_Type__c = null;
                        }

                        // check to see if the valueSelected is a facility or location and set accordingly.
                        else if (valueSelected.split('\\|')[1] == 'Location')
                        {

                            ttWrapper.aTruckTrip.Location_Lookup__c = valueSelected.split('\\|')[0];
                            ttWrapper.aTruckTrip.Facility_Lookup__c = null;
                            ttWrapper.aTruckTrip.Facility_Type__c = 'Location';
                        }

                        else if (valueSelected.split('\\|')[1] == 'Facility')
                        {

                            ttWrapper.aTruckTrip.Facility_Lookup__c = valueSelected.split('\\|')[0];
                            ttWrapper.aTruckTrip.Location_Lookup__c = null;
                            ttWrapper.aTruckTrip.Facility_Type__c = 'Facility';
                        }


                        // Clear the lookup
                        ttWrapper.aTruckTrip.Well__c = null;

                        // Assign Picklist Value
                        ttWrapper.aFacilityPicklistValue = valueSelected;
                    }
                    else if (applyItem == 'unit')
                    {
                        // special processing.  See if the IF statement before this FOR loop
                        
                        if(String.isBlank(valueSelected)) {
                            ttWrapper.aTruckTrip.Unit__c = null;
                            ttWrapper.aTruckTrip.Carrier__c = null;
                        } else if (valueSelected.contains('-')) {
                            ttWrapper.aTruckTrip.Unit__c = valueSelected.split('-').get(1);
                            ttWrapper.aTruckTrip.Carrier__c = valueSelected.split('-').get(0);
                        } else {
                            ttWrapper.aTruckTrip.Unit__c = null;
                            ttWrapper.aTruckTrip.Carrier__c = valueSelected;
                        }
                    }
                    // UPDATED BY GM 2015-08-17 DATA INTEGRITY FIX
                    else if (applyItem == 'shift' && valueSelected != null)
                    {
                        ttWrapper.dispatchShift = valueSelected;
                        ttWrapper.setShiftAndPlannedDate();
                    }
                    // UPDATED BY GM 2015-08-17 DATA INTEGRITY FIX
                    else if (applyItem == 'status' && valueSelected != null)
                    {
                        ttWrapper.aTruckTrip.Truck_Trip_Status__c = valueSelected;
                        if (valueSelected == FM_Utilities.TRUCKTRIP_STATUS_CANCELLED){
                            ttWrapper.aTruckTrip.Load_Request_Cancel_Reason__c = massUpdateCancelReason;
                            ttWrapper.aTruckTrip.Load_Request_Cancel_Comments__c = massUpdateCancelComments;
                        }
                    }
                    //ttWrapper.aCheckBox = false;
                    truckTripList.add(ttWrapper.aTruckTrip);
                }
            }
            if (truckTripList.size() > 0) {
                SaveTruckTrips(false);
            }

            // clear selected TruckTrips after cancelling them
            if (applyItem == 'status' && valueSelected == FM_Utilities.TRUCKTRIP_STATUS_CANCELLED) {
                clearAllTruckTripCheckboxes();
            }
            // clear mass update selections
            clearMassUpdateSelections();
        }
        return null;
    }

    public Boolean getDisplayWellColumn() {
        Boolean standardLoadType = false;
        for(TruckTripWrapper trucktrip : truckListWrapperList) {
            if(trucktrip.aTruckTrip.Load_Type__c != null ) {
                standardLoadType = true;
            }
        }
        return standardLoadType;
    }

    public Boolean getIsExportedTruckTrips() {
        if (truckListWrapperList != null && truckListWrapperList.size() > 0)
            for (TruckTripWrapper trucktrip : truckListWrapperList)
                if (trucktrip.aTruckTrip.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_EXPORTED)
                    return true; 
        return false;
    }

    ///////////////////////////////////////
    // * Utility Functions and Classes * //
    ///////////////////////////////////////

    private List<FM_Truck_Trip__c> getNewTruckTrips(List<FM_Truck_Trip__c> allTruckTrips) {
        List<FM_Truck_Trip__c> newTruckTrips = new List<FM_Truck_Trip__c>();
        for(FM_Truck_Trip__c truckTrip : allTruckTrips) {
            if(truckTrip.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_NEW ||
                trucktrip.Truck_Trip_Status__c == FM_Utilities.TRUCKTRIP_STATUS_REDISPATCH) {
                newTruckTrips.add(truckTrip);
            }
        }
        return newTruckTrips;
    }

    public List<SelectOption> getLoadRequestCancelReasons() {
        return FM_LoadRequest_Utilities.getCancelReasons();
    }
    /**
    Inner class (WRAPPER) - combination of truck trip object, checkbox to record which truck trip record is checked,
    facility picklist value and some other properties/methods
    */

    public class TruckTripWrapper {
        public FM_Truck_Trip__c aTruckTrip {get; set;}
        public Boolean aCheckBox {get; set;}
        public PopupState destinationConfirmationPopupState {get; set;}
        public String aFacilityPicklistValue {get; set;}
        public String dispatchShift {get; set;}

        private Map<String, FM_FacilitySummary.FacilityDataWrapper> facilitySummaryMap;
        private String sourceLocationId;

        public TruckTripWrapper(FM_Truck_Trip__c pTruckTrip, Boolean pCheckBox, 
            Map<String, FM_FacilitySummary.FacilityDataWrapper> pFacilitySummaryMap) {
            this.aTruckTrip = pTruckTrip;
            this.aCheckBox = pCheckBox;
            this.sourceLocationId = ((this.aTruckTrip.Load_Request__r.Source_Facility__c != null) ?
            this.aTruckTrip.Load_Request__r.Source_Facility__c : this.aTruckTrip.Load_Request__r.Source_Location__c);
            this.facilitySummaryMap = pFacilitySummaryMap;
            //Initialize Input Variables
            this.aFacilityPicklistValue = (this.aTruckTrip.Facility_Type__c == 'Location' && this.aTruckTrip.Well__c == null) ? this.aTruckTrip.Location_Lookup__c + '|Location|' + FM_Utilities.facilityMap.get(aTruckTrip.Location_Lookup__c) :
                (this.aTruckTrip.Facility_Type__c == 'Facility') ? this.aTruckTrip.Facility_Lookup__c + '|Facility|' + FM_Utilities.facilityMap.get(aTruckTrip.Facility_Lookup__c) :
                null;

            setDispatchShift();
        }

        private void setDispatchShift() {
            //if shift is night for truck trip, default is night:today
            if(this.aTruckTrip.Shift_Day__c == null) {
                this.dispatchShift = (this.aTruckTrip.Shift__c == 'Night') ? 'night:today' : 'day:tomorrow';
            } else {
                if (this.aTruckTrip.Shift_Day__c == 'Yesterday') {
                    this.dispatchShift = 'night:yesterday';
                } else {
                    Boolean isDateToday = this.aTruckTrip.Shift_Day__c == 'Today';
                    this.dispatchShift = (this.aTruckTrip.Shift__c == 'Night') ? 'night:today' :
                        (isDateToday) ? 'day:today' : 'day:tomorrow';
                }
            }
        }

        public PageReference setShiftAndPlannedDate() {
            if(this.dispatchShift == 'day:today') {
                this.aTruckTrip.Shift__c = 'Day';
                this.aTruckTrip.Shift_Day__c = 'Today';
            } else if(this.dispatchShift == 'night:today') {
                this.aTruckTrip.Shift__c = 'Night';
                this.aTruckTrip.Shift_Day__c = 'Today';
            } else if (this.dispatchShift == 'night:yesterday') { 
                this.aTruckTrip.Shift__c = 'Night';
                this.aTruckTrip.Shift_Day__c = 'Yesterday';
            } else {// (this.dispatchShift == 'day:tomorrow') {
                this.aTruckTrip.Shift__c = 'Day';
                this.aTruckTrip.Shift_Day__c = 'Tomorrow';
            }
            return null;
        }

        public String carrierUnit {
            get {
                if (aTruckTrip.Carrier__c == null) return '';
                if (aTruckTrip.Unit__c == null) return aTruckTrip.Carrier__c;
                return aTruckTrip.Carrier__c + '-' + aTruckTrip.Unit__c;
            }
            set {
                if (String.isNotBlank(value))
                    if (value.contains('-')) {
                        List<String> ids = value.split('-');
                        aTruckTrip.Carrier__c = ids.get(0);
                        aTruckTrip.Unit__c = ids.get(1);
                    } else {
                        aTruckTrip.Carrier__c = value;
                        aTruckTrip.Unit__c = null;
                    }
                else {
                    aTruckTrip.Carrier__c = null;
                    aTruckTrip.Unit__c = null;
                }
            }
        }

        public String carrierUnitReadOnly {
            get {
                if (aTruckTrip == null || aTruckTrip.Carrier__c == null) return '';
                if (aTruckTrip.Carrier__c != null && aTruckTrip.Unit__c == null)  {
                    if (FM_Utilities.carrierMap.containsKey(aTruckTrip.Carrier__c)) 
                        return FM_Utilities.carrierMap.get(aTruckTrip.Carrier__c).Carrier_Name_For_Fluid__c;
                    else 
                        return FM_Utilities.carrierDisabledMap.containsKey(aTruckTrip.Carrier__c) 
                            ? (FM_Utilities.carrierDisabledMap.get(aTruckTrip.Carrier__c).Carrier_Name_For_Fluid__c  + ' (Disabled)')
                            : 'Unknown';
                }
                String result;
                if (FM_Utilities.carrierMap.containsKey(aTruckTrip.Carrier__c)) 
                    result = FM_Utilities.carrierMap.get(aTruckTrip.Carrier__c).Carrier_Name_For_Fluid__c;
                else
                    result = (FM_Utilities.carrierDisabledMap.containsKey(aTruckTrip.Carrier__c) 
                                ? (FM_Utilities.carrierDisabledMap.get(aTruckTrip.Carrier__c).Carrier_Name_For_Fluid__c + ' (Disabled)')
                                : 'Unknown');
                result += ' - ';
                if (FM_Utilities.unitMap.containsKey(aTruckTrip.Unit__c))
                    result +=  FM_Utilities.unitMap.get(aTruckTrip.Unit__c).Name;
                else
                    result += (FM_Utilities.unitDisabledMap.containsKey(aTruckTrip.Unit__c) 
                                ? (FM_Utilities.unitDisabledMap.get(aTruckTrip.Unit__c).Name + ' (Disabled)')
                                : 'Unknown');
                return result;
            } 
            private set;
        }

        public Boolean isCleanLoad {
            get{
                return this.aTruckTrip.Load_Type__c == 'Clean';
            }
            private set;
        }

        public List<SelectOption> lLoadTypes {
            get
            {
                if(lLoadTypes == null)

                {
                    lLoadTypes = FM_Utilities.GetServiceTypes((aTruckTrip.Load_Request__r.Source_Facility__c != null) ? null :
                        new Location__c(Well_Type__c = aTruckTrip.Load_Request__r.Source_Location__r.Well_Type__c,
                            Fluid_Location_Ind__c = aTruckTrip.Load_Request__r.Source_Location__r.Fluid_Location_Ind__c),
                        (aTruckTrip.Load_Request__r.Source_Facility__c != null) ?
                        new Facility__c(Facility_Name_For_Fluid__c = aTruckTrip.Load_Request__r.Source_Facility__r.Facility_Name_For_Fluid__c)
                        : null);
                }
                return lLoadTypes;
            }
            private set;
        }

        public List<SelectOption> facilitySelectOptions
        {
            get {
                if(facilitySelectOptions == null || facilitySelectOptions.isEmpty()) {
                    facilitySelectOptions = new List<SelectOption>();
                    Map<String, List<SelectOption>> categorizedDestinationOptionsMap =
                        (FM_Utilities.dispatchDestinationMap.get(this.sourceLocationId) != null) ? FM_Utilities.dispatchDestinationMap.get(this.sourceLocationId) :
                        new Map<String, List<SelectOption>>{FM_Utilities.DESTINATION_INDEX_FAVORITE_DESTINATIONS => new List<SelectOption>(),
                            FM_Utilities.DESTINATION_INDEX_ALL_DESTINATIONS => FM_Utilities.allDestinationOptions};

                    facilitySelectOptions.add(new SelectOption('', '--None--'));

                    //Add Favorite Items
                    facilitySelectOptions.add(new SelectOption('Favorites', 'Favorites', true));
                    for(SelectOption option : categorizedDestinationOptionsMap.get(FM_Utilities.DESTINATION_INDEX_FAVORITE_DESTINATIONS)) {
                        String facilitySummaryMapKey = option.getValue().split('\\|')[0] + '-' + this.aTruckTrip.Product__c;
                        FM_FacilitySummary.FacilityDataWrapper facilitySummary = this.facilitySummaryMap.get(facilitySummaryMapKey);
                        Boolean isAtCapacity = (facilitySummary != null) ?
                                               ((this.aTruckTrip.Shift__c == 'Day') ? facilitySummary.getIsAtCapacityDay() : facilitySummary.getIsAtCapacityNight()) :
                                               false;
                        //String atCapacityString = (isAtCapacity) ? ' --- At Capacity ---' : '';
                        //option.setLabel('----' + option.getLabel() + atCapacityString);
                        facilitySelectOptions.add(new SelectOption(option.getValue(), option.getLabel() + ((isAtCapacity) ? ' --- At Capacity ---' : '')));
                    }

                    //Add All Items
                    facilitySelectOptions.add(new SelectOption('All', 'All', true));
                    for(SelectOption option : categorizedDestinationOptionsMap.get(FM_Utilities.DESTINATION_INDEX_ALL_DESTINATIONS)) {
                        String facilitySummaryMapKey = option.getValue().split('\\|')[0] + '-' + this.aTruckTrip.Product__c;
                        FM_FacilitySummary.FacilityDataWrapper facilitySummary = this.facilitySummaryMap.get(facilitySummaryMapKey);
                        Boolean isAtCapacity = (facilitySummary != null) ?
                                               ((this.aTruckTrip.Shift__c == 'Day') ? facilitySummary.getIsAtCapacityDay() : facilitySummary.getIsAtCapacityNight()) :
                                               false;
                        //String atCapacityString = (isAtCapacity) ? ' --- At Capacity ---' : '';
                        //option.setLabel('----' + option.getLabel() + atCapacityString);
                        facilitySelectOptions.add(new SelectOption(option.getValue(), option.getLabel() + ((isAtCapacity) ? ' --- At Capacity ---' : '')));
                    }
                }
                return facilitySelectOptions;
            }
            private set;
        }

        public Boolean isDestinationFacilityPopulated {
            get {
                return !String.isBlank(this.aFacilityPicklistValue) && this.aFacilityPicklistValue.split('\\|')[0] <> 'null';
            }
            private set;
        }

        public Boolean isDestinationFacilityAtCapacity {
            get {
                if(!String.isEmpty(this.aFacilityPicklistValue)) {
                    String facilitySummaryMapKey = this.aFacilityPicklistValue.split('\\|')[0] + '-' + this.aTruckTrip.Product__c;
                    FM_FacilitySummary.FacilityDataWrapper facilitySummary = this.facilitySummaryMap.get(facilitySummaryMapKey);
                    return (facilitySummary != null) ?
                           ((this.aTruckTrip.Shift__c == 'Day') ? facilitySummary.getIsAtCapacityDay() : facilitySummary.getIsAtCapacityNight()) :
                           false;
                }

                return false;
            }
            private set;
        }
        
        public PageReference clearFacility() {
            if(aTruckTrip.Well__c != null && aTruckTrip.Load_Type__c == null) {
                aTruckTrip.Facility_Type__c = null;
                this.aFacilityPicklistValue = null;
                aTruckTrip.Facility_Lookup__c = null;
                aTruckTrip.Well__c = null;
                aTruckTrip.Location_Lookup__c = null;
                aFacilityPickListValue = null;
            }
            return null;
        }

        public PageReference SplitFacilityAndLocation()
        {
            if(!String.isBlank(aFacilityPickListValue))
            {
                aTruckTrip.Facility_Type__c = aFacilityPicklistValue.split('\\|')[1];
                if (aTruckTrip.Facility_Type__c == 'Location')
                {
                    aTruckTrip.Location_Lookup__c = aFacilityPicklistValue.split('\\|')[0];
                    aTruckTrip.Facility_Lookup__c = null;
                }
                else if (aTruckTrip.Facility_Type__c == 'Facility')
                {
                    aTruckTrip.Facility_Lookup__c = aFacilityPicklistValue.split('\\|')[0];
                    aTruckTrip.Location_Lookup__c = null;
                }
            }
            else
            {
                aTruckTrip.Facility_Type__c = null;
                aTruckTrip.Facility_Lookup__c = null;
                aTruckTrip.Location_Lookup__c = null;
            }

            aTruckTrip.Well__c = null;

            return null;
        }

        public PageReference populateLocationLookup() {
            if(aTruckTrip.Well__c != null) {
                aTruckTrip.Facility_Type__c = 'Location';
                aTruckTrip.Location_Lookup__c = aTruckTrip.Well__c;
                this.aFacilityPicklistValue = null;
            }
            else {
                aTruckTrip.Facility_Type__c = null;
                aTruckTrip.Location_Lookup__c = null;
                this.aFacilityPicklistValue = null;
            }
            return null;
        }

        public PageReference CutomizeDestinationFavoritesRedirect()
        {
            PageReference oPage = null;
            oPage = Page.FM_CustomizeFacilityFavorites;
            oPage.getParameters().put('funclocId', (aTruckTrip.Load_Request__r.Source_Facility__c != null) ?
                aTruckTrip.Load_Request__r.Source_Facility__c : aTruckTrip.Load_Request__r.Source_Location__c);
            return oPage;
        }

    }

    //inner class for popup state for each truck trip
    public class PopupState {
        public Boolean show {get; private set;}
        public String confirmationMessage {get; private set;}
        public Boolean confirmed {get; set;}
    }

    /**
    DipsatchViewSearchTitle - getter to return title string
    */
    public String getDipsatchViewSearchTitle() {
        String displayString = '';

        if(currentPageFilter.runSheetDate != null) {
            displayString += 'for Run Sheet Date ' + currentPageFilter.runSheetDate.format();
        }

        if(currentPageFilter.searchRoutes != null && !currentPageFilter.searchRoutes.isEmpty()) {
            displayString += ' for Routes ' + currentPageFilter.searchRoutes;
        }

        return displayString;
    }

    /**
    ResultsStats - getter to return statement about how many Truck Trip records are showing on current page (list controller)
    */
    public String getResultsStats() {
        String statsString = '';

        if (truckTripSetController != null) {
            if (truckTripSetController.getResultSize() > 0) {
                if (truckTripSetController.getResultSize() <= truckTripSetController.getPageSize()) {
                    // there are fewer records than the page size, so only page 1
                    statsString = 'Showing 1 to ' + truckTripSetController.getResultSize();
                }
                else {
                    statsString = 'Showing ';
                    statsString += ((truckTripSetController.getPageNumber() - 1) * truckTripSetController.getPageSize() + 1) + ' to ';
                    if (truckTripSetController.getResultSize() <= truckTripSetController.getPageSize() * truckTripSetController.getPageNumber())
                    {
                        // if this current page is the last page
                        statsString += truckTripSetController.getResultSize();
                    }
                    else
                    {
                        // if there are more
                        statsString += truckTripSetController.getPageSize() * truckTripSetController.getPageNumber();
                    }
                }
                statsString += ' of ' + truckTripSetController.getResultSize() + ' loads.';
            }
        }
        return statsString;
    }

    /**
    helper methods for << >> buttons (list controller)
    */
    public PageReference GoNext() {
        FM_Truck_Trip__c t = (FM_Truck_Trip__c)truckTripSetController.getRecord();
        SaveTruckTrips(true);
        truckTripWrapperMap.clear();
        truckTripSetController.next();
        return null;
    }

    public PageReference GoPrevious() {
        SaveTruckTrips(true);
        truckTripWrapperMap.clear();
        truckTripSetController.previous();
        return null;
    }

    public PageReference GoFirst() {
        SaveTruckTrips(true);
        truckTripWrapperMap.clear();
        truckTripSetController.first();
        return null;
    }

    public PageReference GoLast() {
        SaveTruckTrips(true);
        truckTripWrapperMap.clear();
        truckTripSetController.last();
        return null;
    }

    private void LoadUrlParameters() {
        String filterString = ApexPages.currentPage().getParameters().get('filter');
        String sortOptionString = ApexPages.currentPage().getParameters().get('sortOptions');

        currentPageFilter = (!String.isEmpty(filterString)) ?
            (FilterWrapper) JSON.deserialize(filterString, FilterWrapper.class) :
            new FilterWrapper();
        sortOptions = (!String.isEmpty(sortOptionString)) ?
            (SortingWrapper) JSON.deserialize(sortOptionString, SortingWrapper.class):
            new SortingWrapper();

        String sRouteData = (ApexPages.currentPage().getParameters().get('dv_route') != null) ? EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_route'), 'utf-8') : null;
        currentPageFilter.searchRoutes = (sRouteData != null) ? sRouteData.split(',') : new List<String>();
        currentPageFilter.runSheetDate = (ApexPages.currentPage().getParameters().get('dv_date') != null) ? Date.valueOf( EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_date'), 'utf-8')) : Date.today();
        currentPageFilter.unit = (ApexPages.currentPage().getParameters().get('dv_unit') != null) ? EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_unit'), 'utf-8') : '';
        currentPageFilter.shift = (ApexPages.currentPage().getParameters().get('dv_shift') != null) ? EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_shift'), 'utf-8') : '';
        currentPageFilter.truckTripStatus = (ApexPages.currentPage().getParameters().get('dv_status') != null) ? EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_status'), 'utf-8') : '';
        currentPageFilter.sour = (ApexPages.currentPage().getParameters().get('dv_sour') != null) ? Boolean.valueOf(EncodingUtil.urlDecode(ApexPages.currentPage().getParameters().get('dv_sour'), 'utf-8')) : null;
    }

    public class SortingWrapper {
        public String sortField {get; set;}
        public String sortDirection {get; set;}
        public String lastSortField {get; set;}

        public SortingWrapper() {
            clear();
        }

        public void clear() {
            sortField = 'Shift__c';
            sortDirection = 'desc NULLS LAST';
            lastSortField = sortField;
        }

        public String getSortString() {
            if (sortField == 'Unit__r.Name') 
                return ' ORDER BY ' + String.escapeSingleQuotes('Carrier__c') +
                    ' ' + String.escapeSingleQuotes(sortDirection) + 
                    ', ' + String.escapeSingleQuotes(sortField) +
                    ' ' + String.escapeSingleQuotes(sortDirection) + 
                    ' LIMIT 10000';
            return ' ORDER BY ' + String.escapeSingleQuotes(sortField) +
                ' ' + String.escapeSingleQuotes(sortDirection) +
                ' LIMIT 10000';
        }
    }

    public class FilterWrapper {
        public List<String> searchRoutes {get; set;}
        public Date runSheetDate {get; set;}
        public Boolean sour {get; set;}
        public String unit {get; set;}
        public String shift {get; set;}
        public String truckTripStatus {get; set;}
        public String sortField {get; set;}
        public String sortDirection {get; set;}
        public String lastSortField {get; set;}
        public String product {get; set;}
        public String axle {get; set;}
        public String searchFacility {get; set;}
        //public String searchLocation {get; set;}

        public FilterWrapper() {
            clear();
        }

        public void clear() {
            if(searchRoutes != null) searchRoutes.clear();
            else searchRoutes =  new List<String>();
            runSheetDate = Date.today();
            sour = null;
            unit = '';
            shift = '';
            truckTripStatus = '';
            sortField = '';
            sortDirection = '';
            product = '';
            axle = '';
            searchFacility = '';
            //searchLocation = '';
        }

        public String getFilterString() {
            String whereClause = ' WHERE (Load_Request__c != null)';
            whereClause += ' AND Truck_Trip_Status__c != \'' + FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED + '\' ';
            whereClause += ' AND Truck_Trip_Status__c != \'' + FM_Utilities.TRUCKTRIP_STATUS_COMPLETED + '\' ';
            //whereClause += ' AND Truck_Trip_Status__c != \'' + FM_Utilities.TRUCKTRIP_STATUS_EXPORTED + '\' ';
            whereClause += ' AND Truck_Trip_Status__c != \'' + FM_Utilities.TRUCKTRIP_STATUS_ADDON + '\' ';
            whereClause += ' AND Truck_Trip_Status__c != \'' + FM_TruckTrip_Utilities.STATUS_UNCANCELLED + '\' ';

            if (!String.isBlank(String.valueOf(runSheetDate))) {
                whereClause += ' AND Run_Sheet_Date__c = ' + String.valueOf(runSheetDate) + ' ';
            }
            else {
                whereClause += ' AND Run_Sheet_Date__c = null ';
            }

            if(searchRoutes != null && !searchRoutes.isEmpty()) {
                whereClause += ' AND Route__c IN (\'' + String.join(this.searchRoutes, '\', \'') + '\') ';
            } else {
                whereClause += ' AND Route__c = null ';
            }

            if (!String.isEmpty(product)) {
                whereClause += ' AND Product__c = \'' + String.escapeSingleQuotes(product) + '\' ';
            }
            if (!String.isEmpty(axle)) {
                whereClause += ' AND Axle__c = \'' + String.escapeSingleQuotes(axle) + '\' ';
            }
            if(sour != null) {
                whereClause += ' AND Sour__c = ';
                whereClause += (sour == true) ? ' true ' : ' false ';
            }

            if (!String.isEmpty(unit))
            {
                whereClause += ' AND Unit__c = \'' + String.escapeSingleQuotes(unit) + '\' ';
            }
            if (!String.isEmpty(shift))
            {
                String shiftStr = '';
                String shiftDayStr = '';
                if(shift == 'day:today') {
                    shiftStr = 'Day';
                    shiftDayStr = 'Today';
                } else if(shift == 'night:today') {
                    shiftStr = 'Night';
                    shiftDayStr = 'Today';
                } else if (shift == 'night:yesterday') { 
                    shiftStr = 'Night';
                    shiftDayStr = 'Yesterday';
                } else {// (this.dispatchShift == 'day:tomorrow') {
                    shiftStr = 'Day';
                    shiftDayStr = 'Tomorrow';
                }
                whereClause += ' AND Shift__c = \'' + String.escapeSingleQuotes(shiftStr) + '\' ';
                whereClause += ' AND Shift_Day__c = \'' + String.escapeSingleQuotes(shiftDayStr) + '\' ';
            }
            if (!String.isEmpty(truckTripStatus))
            {
                whereClause += ' AND Truck_Trip_Status__c = \'' + String.escapeSingleQuotes(truckTripStatus) + '\' ';
            }

            if (!String.isBlank(searchFacility)) {
                String facilityType = searchFacility.split('\\|')[1];
                if (facilityType == 'Facility') {
                    whereClause += ' AND Facility_Lookup__c = \'' + String.escapeSingleQuotes(searchFacility.split('\\|')[0]) + '\' ';
                }
                else if (facilityType == 'Location'){
                    whereClause += ' AND Location_Lookup__c = \'' + String.escapeSingleQuotes(searchFacility.split('\\|')[0]) + '\' ';
                }
            }

            // if (!String.isEmpty(searchLocation)) {
            //     whereClause += ' AND (Run_Sheet_Lookup__r.Well__c = \'' + searchLocation + '\' OR Run_Sheet_Lookup__r.Facility__c = \'' + searchLocation + '\') ';
            // }

            return whereClause;
        }

    }
}